//MetronomeL2.cs


datablock AudioProfile(MetronomeL2ExplosionSound)
{
   filename    = "./MetronomeL2Fire.wav";
   description = AudioClose3d;
   preload = false;
};

datablock AudioProfile(MetronomeL2FireSound)
{
   filename    = "./MetronomeL2Fire.wav";
   description = AudioClose3d;
   preload = true;
};


//MetronomeL2 trail
datablock ParticleData(MetronomeL2TrailParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/thinRing";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.0 0.6 1.0";
	colors[1]     = "0.0 0.8 0.8 0.1";
   colors[2]     = "0.7 0.7 0.7 0.3";
   sizes[0]      = 0.1;
	sizes[1]      = 2.0;
	sizes[2]      = 0.5;

   times[0] = 1.0;
   times[1] = 0.5;
   times[2] = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(MetronomeL2TrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = MetronomeL2TrailParticle;
};

//MetronomeL2 trail2
datablock ParticleData(MetronomeL2TrailParticle2)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 700;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 1000.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "./glare";
	//animTexName		= "./dot";

	// Interpolation variables
	colors[0]     = "1.0 1.0 1.0 0.8";
   	colors[1]     = "1.0 1.0 1.0 0.8";
	sizes[0]	= 0.1;
	sizes[1]	= 0.0;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(MetronomeL2TrailEmitter2)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = MetronomeL2TrailParticle2;
};


//effects
datablock ParticleData(MetronomeL2ExplosionParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.5;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 1.0;
	lifetimeMS		= 900;
	lifetimeVarianceMS	= 300;
	spinSpeed		= 20.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/thinRing";
	//animTexName		= "./sparkspin";

	// Interpolation variables
	colors[0]     = "0.1 0.0 .6 0.8";
   	colors[1]     = "0.1 0.0 .6 0.8";
	sizes[0]	= 1.8;
	sizes[1]	= 1.0;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(MetronomeL2ExplosionEmitter)
{
   ejectionPeriodMS = 9;
   periodVarianceMS = 0;
   lifeTimeMS	   = 21;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MetronomeL2ExplosionParticle";
};

datablock ParticleData(MetronomeL2ExplosionParticle2)
{
	dragCoefficient		= 0.1;
	windCoefficient		= 0.0;
	gravityCoefficient	= 2.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1000;
	lifetimeVarianceMS	= 500;
	spinSpeed		= 20.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "base/data/particles/thinRing";
	//animTexName		= "./sparkspin";

	// Interpolation variables
	colors[0]     = "0.1 0.0 .6 0.8";
   	colors[1]     = "0.1 0.0 .6 0.8";
	sizes[0]	= 0.8;
	sizes[1]	= 0.5;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(MetronomeL2ExplosionEmitter2)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   lifetimeMS       = 10;
   ejectionVelocity = 15;
   velocityVariance = 5.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "MetronomeL2ExplosionParticle2";
};

datablock ExplosionData(MetronomeL2Explosion)
{
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = MetronomeL2ExplosionSound;

   emitter[0] = MetronomeL2ExplosionEmitter;
   emitter[1] = MetronomeL2ExplosionEmitter2;
   particleDensity = 5000;
   particleRadius = 10.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 4;
   lightEndRadius = 3;
   lightStartColor = "0.45 0.3 0.1";
   lightEndColor = "0 0 0";

   //impulse
   impulseRadius = 0;
   impulseForce = 99999;

   //radius damage
   radiusDamage        = 0;
   damageRadius        = 3.5;
};

//projectile
datablock ProjectileData(MetronomeL2Projectile)
{
   projectileShapeName = "";
   directDamage        = 20;
   impactImpulse	   = -999999999999;
   verticalImpulse	   = 100000;
   explosion           = MetronomeL2Explosion;
   particleEmitter     = MetronomeL2TrailEmitter;
   particleEmitter2    = MetronomeL2TrailEmitter2;

   brickExplosionRadius = 0;
   brickExplosionImpact = true; //destroy a brick if we hit it directly?
   brickExplosionForce  = 999;
   brickExplosionMaxVolume = 0;
   brickExplosionMaxVolumeFloating = 0;

   muzzleVelocity      = 1;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 2000000;
   fadeDelay           = 19500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

     //burn the players?
   playerBurnTime = 20000;

   uiName = "MetronomeL2";
};


//////////
// item //
//////////
datablock ItemData(MetronomeL2Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./EmptyHand.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Metronome L16-35";
	iconName = "./Impulse_Icon";
	doColorShift = true;
	colorShiftColor = "0.1 0.0 0.8 1.000";

	 // Dynamic properties defined by the scripts
	image = MetronomeL2Image;
	canDrop = true;
};

//function MetronomeL2::onUse(%this,%user)
//{
//	//mount the image in the right hand slot
//	%user.mountimage(%this.image, $RightHandSlot);
//}

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MetronomeL2Image)
{
   // Basic Item properties
   shapeFile = "./EmptyHand.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 -0.5";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MetronomeL2Item;
   ammo = " ";
   projectile = MetronomeL2Projectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.1 0.0 0.8 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 0.7;
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateScript[2]                  = "onCharge";
	stateAllowImageChange[2]        = false;
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.3;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= false;

	stateName[4]			= "Armed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateAllowImageChange[4]	= false;

	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.5;
	stateFire[5]			= true;
	stateSequence[5]		= "fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
	stateSound[5]				= MetronomeL2FireSound;
};

function MetronomeL2Image::onCharge(%this, %obj, %slot)
{
	%obj.playthread(2, SpearReady);
}

function MetronomeL2Image::onAbortCharge(%this, %obj, %slot)
{
	%obj.playthread(2, root);
}

function MetronomeL2Image::onFire(%this, %obj, %slot)
{
	%obj.playthread(2, SpearThrow);
	Parent::onFire(%this, %obj, %slot);
}